
Foreman - Bug #3864

Change ignore_puppet_facts_for_provisioning default to true

12/12/2013 08:48 AM - Dominic Cleal

Status: Rejected   

Priority: Normal   

Assignee:    

Category: Settings   

Target version:    

Difficulty:  Fixed in Releases:  

Triaged:  Found in Releases:  

Bugzilla link:  Red Hat JIRA:  

Pull request:    

Description

Proposal to change the ignore_puppet_facts_for_provisioning setting to true, so we don't change IPs and MACs of managed hosts

(since dbc4dc306 this seems to be the only use).  Not doing so causes the host record to get out of sync with DHCP reservations

etc, when the host might not be provisioned from its "primary" interface (the one that Facter identifies).

(https://bugzilla.redhat.com/show_bug.cgi?id=1040262)

Related issues:

Related to Foreman - Bug #3865: DHCP reservation on old MAC can't be updated ... New 12/12/2013

Related to Foreman - Feature #3554: Enable provisioning on non-primary interface Resolved 11/01/2013

Related to Foreman - Tracker #2409: Networking New

Related to Foreman - Bug #8767: Foreman removes wrong DNS entry for openstack VM New 12/19/2014

Related to Foreman - Feature #9104: Disable auto network interfaces Closed 01/25/2015

Has duplicate Foreman - Bug #6863: Foreman shouldn't use facts of machine to ... Duplicate 07/31/2014

History

#1 - 12/12/2013 08:52 AM - Dominic Cleal

- Related to Bug #3865: DHCP reservation on old MAC can't be updated when MAC changes due to update from facts added

#2 - 12/17/2013 08:43 AM - Dominic Cleal

- Related to Feature #3554: Enable provisioning on non-primary interface added

#3 - 07/31/2014 10:11 AM - Dominic Cleal

- Has duplicate Bug #6863: Foreman shouldn't use facts of machine to determine VM ip added

#4 - 07/31/2014 10:27 AM - Jon Skarpeteig

Changing the ignore_puppet_facts_for_provisioning option for existing host, doesn't work.

The below error is with a manual entry in the ip address field with the correct value - yet Foreman insists on using the invalid one.

Delete the DNS PTR record for 172.17.10.10/fqdn

Remove Reverse DNS record for fqdn task failed with the following error: ERF12-1261 [ProxyAPI::ProxyException]

: Unable to delete DNS entry    ([RestClient::BadRequest]: 400 Bad Request) for proxy https://foreman:8443/dns

/usr/share/foreman/lib/proxy_api/dns.rb:27:in `rescue in delete'

/usr/share/foreman/lib/proxy_api/dns.rb:22:in `delete'

/usr/share/foreman/lib/net/dns/ptr_record.rb:15:in `destroy'

/usr/share/foreman/app/models/concerns/orchestration/dns.rb:54:in `del_dns_ptr_record'

/usr/share/foreman/app/models/concerns/orchestration.rb:137:in `execute'

/usr/share/foreman/app/models/concerns/orchestration.rb:85:in `block in process'

/usr/share/foreman/app/models/concerns/orchestration.rb:77:in `each'

/usr/share/foreman/app/models/concerns/orchestration.rb:77:in `process'

/usr/share/foreman/app/models/concerns/orchestration.rb:18:in `on_save'

/usr/share/foreman/vendor/ruby/1.9.1/gems/activesupport-3.2.18/lib/active_support/callbacks.rb:649:in `_run__4

121150721801184260__save__1432869149087012296   __callbacks'

/usr/share/foreman/vendor/ruby/1.9.1/gems/activesupport-3.2.18/lib/active_support/callbacks.rb:405:in `__run_c
allback'

/usr/share/foreman/vendor/ruby/1.9.1/gems/activesupport-3.2.18/lib/active_support/callbacks.rb:385:in `_run_sa

ve_callbacks'

/usr/share/foreman/vendor/ruby/1.9.1/gems/activesupport-3.2.18/lib/active_support/callbacks.rb:81:in `run_call

backs'

/usr/share/foreman/vendor/ruby/1.9.1/gems/activerecord-3.2.18/lib/active_record/callbacks.rb:264:in `create_or

_update'

/usr/share/foreman/vendor/ruby/1.9.1/gems/activerecord-3.2.18/lib/active_record/persistence.rb:84:in `save'

/usr/share/foreman/vendor/ruby/1.9.1/gems/activerecord-3.2.18/lib/active_record/validations.rb:50:in `save'

/usr/share/foreman/vendor/ruby/1.9.1/gems/activerecord-3.2.18/lib/active_record/attribute_methods/dirty.rb:22:

in `save'

/usr/share/foreman/vendor/ruby/1.9.1/gems/activerecord-3.2.18/lib/active_record/transactions.rb:259:in `block 

(2 levels) in save'

/usr/share/foreman/vendor/ruby/1.9.1/gems/activerecord-3.2.18/lib/active_record/transactions.rb:313:in `block 

in with_transaction_returning_status'

/usr/share/foreman/vendor/ruby/1.9.1/gems/activerecord-3.2.18/lib/active_record/connection_adapters/abstract/d

atabase_statements.rb:192:in `transaction'

/usr/share/foreman/vendor/ruby/1.9.1/gems/activerecord-3.2.18/lib/active_record/transactions.rb:208:in `transa

ction'

/usr/share/foreman/vendor/ruby/1.9.1/gems/activerecord-3.2.18/lib/active_record/transactions.rb:311:in `with_t

ransaction_returning_status'

/usr/share/foreman/vendor/ruby/1.9.1/gems/activerecord-3.2.18/lib/active_record/transactions.rb:259:in `block 

in save'

/usr/share/foreman/vendor/ruby/1.9.1/gems/activerecord-3.2.18/lib/active_record/transactions.rb:270:in `rollba

ck_active_record_state!'

/usr/share/foreman/vendor/ruby/1.9.1/gems/activerecord-3.2.18/lib/active_record/transactions.rb:258:in `save'

/usr/share/foreman/app/models/concerns/foreman/sti.rb:29:in `save_with_type'

/usr/share/foreman/vendor/ruby/1.9.1/gems/activerecord-3.2.18/lib/active_record/persistence.rb:217:in `block i

n update_attributes'

/usr/share/foreman/vendor/ruby/1.9.1/gems/activerecord-3.2.18/lib/active_record/transactions.rb:313:in `block 

in with_transaction_returning_status'

/usr/share/foreman/vendor/ruby/1.9.1/gems/activerecord-3.2.18/lib/active_record/connection_adapters/abstract/d

atabase_statements.rb:192:in `transaction'

/usr/share/foreman/vendor/ruby/1.9.1/gems/activerecord-3.2.18/lib/active_record/transactions.rb:208:in `transa

ction'

/usr/share/foreman/vendor/ruby/1.9.1/gems/activerecord-3.2.18/lib/active_record/transactions.rb:311:in `with_t

ransaction_returning_status'

/usr/share/foreman/vendor/ruby/1.9.1/gems/activerecord-3.2.18/lib/active_record/persistence.rb:215:in `update_

attributes'

/usr/share/foreman/app/controllers/hosts_controller.rb:113:in `block in update'

/usr/share/foreman/app/models/taxonomy.rb:41:in `block in no_taxonomy_scope'

/usr/share/foreman/app/models/taxonomy.rb:48:in `block (2 levels) in as_taxonomy'

/usr/share/foreman/app/models/concerns/foreman/thread_session.rb:143:in `as_location'

/usr/share/foreman/app/models/taxonomy.rb:47:in `block in as_taxonomy'

/usr/share/foreman/app/models/concerns/foreman/thread_session.rb:108:in `as_org'

/usr/share/foreman/app/models/taxonomy.rb:46:in `as_taxonomy'

/usr/share/foreman/app/models/taxonomy.rb:40:in `no_taxonomy_scope'

/usr/share/foreman/app/controllers/hosts_controller.rb:105:in `update'

/usr/share/foreman/vendor/ruby/1.9.1/gems/actionpack-3.2.18/lib/action_controller/metal/implicit_render.rb:4:i

n `send_action'

/usr/share/foreman/vendor/ruby/1.9.1/gems/actionpack-3.2.18/lib/abstract_controller/base.rb:167:in `process_ac

tion'

/usr/share/foreman/vendor/ruby/1.9.1/gems/actionpack-3.2.18/lib/action_controller/metal/rendering.rb:10:in `pr

ocess_action'

/usr/share/foreman/vendor/ruby/1.9.1/gems/actionpack-3.2.18/lib/abstract_controller/callbacks.rb:18:in `block 

in process_action'

/usr/share/foreman/vendor/ruby/1.9.1/gems/activesupport-3.2.18/lib/active_support/callbacks.rb:549:in `block (

3 levels) in _run__954456653191288785__proces   s_action__157362345750752883__callbacks'

/usr/share/foreman/vendor/ruby/1.9.1/gems/activesupport-3.2.18/lib/active_support/callbacks.rb:215:in `block i

n _conditional_callback_around_6410'

/usr/share/foreman/vendor/ruby/1.9.1/gems/activesupport-3.2.18/lib/active_support/callbacks.rb:326:in `around'

/usr/share/foreman/vendor/ruby/1.9.1/gems/activesupport-3.2.18/lib/active_support/callbacks.rb:310:in `_callba

ck_around_1584'

/usr/share/foreman/vendor/ruby/1.9.1/gems/activesupport-3.2.18/lib/active_support/callbacks.rb:214:in `_condit

ional_callback_around_6410'

/usr/share/foreman/vendor/ruby/1.9.1/gems/activesupport-3.2.18/lib/active_support/callbacks.rb:526:in `block (

2 levels) in _run__954456653191288785__proces   s_action__157362345750752883__callbacks'

/usr/share/foreman/vendor/ruby/1.9.1/gems/activesupport-3.2.18/lib/active_support/callbacks.rb:215:in `block i

n _conditional_callback_around_6409'

/usr/share/foreman/app/models/concerns/foreman/thread_session.rb:33:in `clear_thread'

/usr/share/foreman/vendor/ruby/1.9.1/gems/activesupport-3.2.18/lib/active_support/callbacks.rb:214:in `_condit

ional_callback_around_6409'

/usr/share/foreman/vendor/ruby/1.9.1/gems/activesupport-3.2.18/lib/active_support/callbacks.rb:415:in `block i

n _run__954456653191288785__process_action__1   57362345750752883__callbacks'

/usr/share/foreman/vendor/ruby/1.9.1/gems/activesupport-3.2.18/lib/active_support/callbacks.rb:215:in `block i
n _conditional_callback_around_6408'

/usr/share/foreman/vendor/ruby/1.9.1/gems/activesupport-3.2.18/lib/active_support/callbacks.rb:326:in `around'

/usr/share/foreman/vendor/ruby/1.9.1/gems/activesupport-3.2.18/lib/active_support/callbacks.rb:310:in `_callba

ck_around_13'

/usr/share/foreman/vendor/ruby/1.9.1/gems/activesupport-3.2.18/lib/active_support/callbacks.rb:214:in `_condit

ional_callback_around_6408'

/usr/share/foreman/vendor/ruby/1.9.1/gems/activesupport-3.2.18/lib/active_support/callbacks.rb:414:in `_run__9

54456653191288785__process_action__1573623457   50752883__callbacks'

/usr/share/foreman/vendor/ruby/1.9.1/gems/activesupport-3.2.18/lib/active_support/callbacks.rb:405:in `__run_c

allback'

/usr/share/foreman/vendor/ruby/1.9.1/gems/activesupport-3.2.18/lib/active_support/callbacks.rb:385:in `_run_pr

ocess_action_callbacks'

/usr/share/foreman/vendor/ruby/1.9.1/gems/activesupport-3.2.18/lib/active_support/callbacks.rb:81:in `run_call

backs'

/usr/share/foreman/vendor/ruby/1.9.1/gems/actionpack-3.2.18/lib/abstract_controller/callbacks.rb:17:in `proces

s_action'

/usr/share/foreman/vendor/ruby/1.9.1/gems/actionpack-3.2.18/lib/action_controller/metal/rescue.rb:29:in `proce

ss_action'

/usr/share/foreman/vendor/ruby/1.9.1/gems/actionpack-3.2.18/lib/action_controller/metal/instrumentation.rb:30:

in `block in process_action'

/usr/share/foreman/vendor/ruby/1.9.1/gems/activesupport-3.2.18/lib/active_support/notifications.rb:123:in `blo

ck in instrument'

/usr/share/foreman/vendor/ruby/1.9.1/gems/activesupport-3.2.18/lib/active_support/notifications/instrumenter.r

b:20:in `instrument'

/usr/share/foreman/vendor/ruby/1.9.1/gems/activesupport-3.2.18/lib/active_support/notifications.rb:123:in `ins

trument'

/usr/share/foreman/vendor/ruby/1.9.1/gems/actionpack-3.2.18/lib/action_controller/metal/instrumentation.rb:29:

in `process_action'

/usr/share/foreman/vendor/ruby/1.9.1/gems/actionpack-3.2.18/lib/action_controller/metal/params_wrapper.rb:207:

in `process_action'

/usr/share/foreman/vendor/ruby/1.9.1/gems/activerecord-3.2.18/lib/active_record/railties/controller_runtime.rb

:18:in `process_action'

/usr/share/foreman/vendor/ruby/1.9.1/gems/actionpack-3.2.18/lib/abstract_controller/base.rb:121:in `process'

/usr/share/foreman/vendor/ruby/1.9.1/gems/actionpack-3.2.18/lib/abstract_controller/rendering.rb:45:in `proces

s'

/usr/share/foreman/vendor/ruby/1.9.1/gems/actionpack-3.2.18/lib/action_controller/metal.rb:203:in `dispatch'

/usr/share/foreman/vendor/ruby/1.9.1/gems/actionpack-3.2.18/lib/action_controller/metal/rack_delegation.rb:14:

in `dispatch'

/usr/share/foreman/vendor/ruby/1.9.1/gems/actionpack-3.2.18/lib/action_controller/metal.rb:246:in `block in ac

tion'

/usr/share/foreman/vendor/ruby/1.9.1/gems/actionpack-3.2.18/lib/action_dispatch/routing/route_set.rb:73:in `ca

ll'

/usr/share/foreman/vendor/ruby/1.9.1/gems/actionpack-3.2.18/lib/action_dispatch/routing/route_set.rb:73:in `di

spatch'

/usr/share/foreman/vendor/ruby/1.9.1/gems/actionpack-3.2.18/lib/action_dispatch/routing/route_set.rb:36:in `ca

ll'

/usr/share/foreman/vendor/ruby/1.9.1/gems/journey-1.0.4/lib/journey/router.rb:68:in `block in call'

/usr/share/foreman/vendor/ruby/1.9.1/gems/journey-1.0.4/lib/journey/router.rb:56:in `each'

/usr/share/foreman/vendor/ruby/1.9.1/gems/journey-1.0.4/lib/journey/router.rb:56:in `call'

/usr/share/foreman/vendor/ruby/1.9.1/gems/actionpack-3.2.18/lib/action_dispatch/routing/route_set.rb:608:in `c

all'

/usr/share/foreman/vendor/ruby/1.9.1/gems/apipie-rails-0.1.3/lib/apipie/static_dispatcher.rb:65:in `call'

/usr/share/foreman/vendor/ruby/1.9.1/gems/apipie-rails-0.1.3/lib/apipie/middleware/checksum_in_headers.rb:27:i

n `call'

/usr/share/foreman/vendor/ruby/1.9.1/gems/actionpack-3.2.18/lib/action_dispatch/middleware/best_standards_supp

ort.rb:17:in `call'

/usr/share/foreman/vendor/ruby/1.9.1/gems/rack-1.4.5/lib/rack/etag.rb:23:in `call'

/usr/share/foreman/vendor/ruby/1.9.1/gems/rack-1.4.5/lib/rack/conditionalget.rb:35:in `call'

/usr/share/foreman/vendor/ruby/1.9.1/gems/actionpack-3.2.18/lib/action_dispatch/middleware/head.rb:14:in `call

'

/usr/share/foreman/vendor/ruby/1.9.1/gems/actionpack-3.2.18/lib/action_dispatch/middleware/params_parser.rb:21

:in `call'

/usr/share/foreman/lib/middleware/catch_json_parse_errors.rb:9:in `call'

/usr/share/foreman/vendor/ruby/1.9.1/gems/actionpack-3.2.18/lib/action_dispatch/middleware/flash.rb:242:in `ca

ll'

/usr/share/foreman/vendor/ruby/1.9.1/gems/rack-1.4.5/lib/rack/session/abstract/id.rb:210:in `context'

/usr/share/foreman/vendor/ruby/1.9.1/gems/rack-1.4.5/lib/rack/session/abstract/id.rb:205:in `call'

/usr/share/foreman/vendor/ruby/1.9.1/gems/actionpack-3.2.18/lib/action_dispatch/middleware/cookies.rb:341:in `

call'

/usr/share/foreman/vendor/ruby/1.9.1/gems/activerecord-3.2.18/lib/active_record/query_cache.rb:64:in `call'

/usr/share/foreman/vendor/ruby/1.9.1/gems/activerecord-3.2.18/lib/active_record/connection_adapters/abstract/c

onnection_pool.rb:479:in `call'

/usr/share/foreman/vendor/ruby/1.9.1/gems/actionpack-3.2.18/lib/action_dispatch/middleware/callbacks.rb:28:in 

`block in call'

/usr/share/foreman/vendor/ruby/1.9.1/gems/activesupport-3.2.18/lib/active_support/callbacks.rb:405:in `_run__2
81912894283823804__call__1432869149087012296_   _callbacks'

/usr/share/foreman/vendor/ruby/1.9.1/gems/activesupport-3.2.18/lib/active_support/callbacks.rb:405:in `__run_c

allback'

/usr/share/foreman/vendor/ruby/1.9.1/gems/activesupport-3.2.18/lib/active_support/callbacks.rb:385:in `_run_ca

ll_callbacks'

/usr/share/foreman/vendor/ruby/1.9.1/gems/activesupport-3.2.18/lib/active_support/callbacks.rb:81:in `run_call

backs'

/usr/share/foreman/vendor/ruby/1.9.1/gems/actionpack-3.2.18/lib/action_dispatch/middleware/callbacks.rb:27:in 

`call'

/usr/share/foreman/vendor/ruby/1.9.1/gems/actionpack-3.2.18/lib/action_dispatch/middleware/remote_ip.rb:31:in 

`call'

/usr/share/foreman/vendor/ruby/1.9.1/gems/actionpack-3.2.18/lib/action_dispatch/middleware/debug_exceptions.rb

:16:in `call'

/usr/share/foreman/vendor/ruby/1.9.1/gems/actionpack-3.2.18/lib/action_dispatch/middleware/show_exceptions.rb:

56:in `call'

/usr/share/foreman/vendor/ruby/1.9.1/gems/railties-3.2.18/lib/rails/rack/logger.rb:32:in `call_app'

/usr/share/foreman/vendor/ruby/1.9.1/gems/railties-3.2.18/lib/rails/rack/logger.rb:16:in `block in call'

/usr/share/foreman/vendor/ruby/1.9.1/gems/activesupport-3.2.18/lib/active_support/tagged_logging.rb:22:in `tag

ged'

/usr/share/foreman/vendor/ruby/1.9.1/gems/railties-3.2.18/lib/rails/rack/logger.rb:16:in `call'

/usr/share/foreman/vendor/ruby/1.9.1/gems/actionpack-3.2.18/lib/action_dispatch/middleware/request_id.rb:22:in

 `call'

/usr/share/foreman/vendor/ruby/1.9.1/gems/rack-1.4.5/lib/rack/methodoverride.rb:21:in `call'

/usr/share/foreman/vendor/ruby/1.9.1/gems/rack-1.4.5/lib/rack/runtime.rb:17:in `call'

/usr/share/foreman/vendor/ruby/1.9.1/gems/activesupport-3.2.18/lib/active_support/cache/strategy/local_cache.r

b:72:in `call'

/usr/share/foreman/vendor/ruby/1.9.1/gems/rack-1.4.5/lib/rack/lock.rb:15:in `call'

/usr/share/foreman/vendor/ruby/1.9.1/gems/actionpack-3.2.18/lib/action_dispatch/middleware/static.rb:63:in `ca

ll'

/usr/share/foreman/vendor/ruby/1.9.1/gems/rack-cache-1.2/lib/rack/cache/context.rb:136:in `forward'

/usr/share/foreman/vendor/ruby/1.9.1/gems/rack-cache-1.2/lib/rack/cache/context.rb:143:in `pass'

/usr/share/foreman/vendor/ruby/1.9.1/gems/rack-cache-1.2/lib/rack/cache/context.rb:155:in `invalidate'

/usr/share/foreman/vendor/ruby/1.9.1/gems/rack-cache-1.2/lib/rack/cache/context.rb:71:in `call!'

/usr/share/foreman/vendor/ruby/1.9.1/gems/rack-cache-1.2/lib/rack/cache/context.rb:51:in `call'

/usr/share/foreman/vendor/ruby/1.9.1/gems/railties-3.2.18/lib/rails/engine.rb:484:in `call'

/usr/share/foreman/vendor/ruby/1.9.1/gems/railties-3.2.18/lib/rails/application.rb:231:in `call'

/usr/share/foreman/vendor/ruby/1.9.1/gems/railties-3.2.18/lib/rails/railtie/configurable.rb:30:in `method_miss

ing'

/usr/share/foreman/vendor/ruby/1.9.1/gems/rack-1.4.5/lib/rack/builder.rb:134:in `call'

/usr/share/foreman/vendor/ruby/1.9.1/gems/rack-1.4.5/lib/rack/urlmap.rb:64:in `block in call'

/usr/share/foreman/vendor/ruby/1.9.1/gems/rack-1.4.5/lib/rack/urlmap.rb:49:in `each'

/usr/share/foreman/vendor/ruby/1.9.1/gems/rack-1.4.5/lib/rack/urlmap.rb:49:in `call'

/usr/lib/ruby/vendor_ruby/phusion_passenger/rack/thread_handler_extension.rb:77:in `process_request'

/usr/lib/ruby/vendor_ruby/phusion_passenger/request_handler/thread_handler.rb:142:in `accept_and_process_next_

request'

/usr/lib/ruby/vendor_ruby/phusion_passenger/request_handler/thread_handler.rb:110:in `main_loop'

/usr/lib/ruby/vendor_ruby/phusion_passenger/request_handler.rb:448:in `block (3 levels) in start_threads'

#5 - 09/02/2014 04:10 AM - Marek Hulán

- Related to Tracker #2409: Networking added

#6 - 09/02/2014 04:12 AM - Marek Hulán

With upcoming networking changes in 1.7, there are more attributes that will be updated. Having ignore_puppet_facts_for_provisioning disabled will

allow creation of network interfaces based on facts.

#7 - 01/02/2015 04:54 AM - Dominic Cleal

- Related to Bug #8767: Foreman removes wrong DNS entry for openstack VM added

#8 - 01/26/2015 04:35 AM - Dominic Cleal

- Related to Feature #9104: Disable auto network interfaces added

#9 - 08/27/2015 05:03 AM - Lukas Zapletal

In other words, starting from Foreman 1.8+ our networking parsing code does not rely on how facter reports "main" interface, it does not re-assign

primary interface, therefore it is not needed to set this flag to true anymore.

#10 - 02/25/2016 03:40 AM - Marek Hulán

I agree with Lukas. Does anyone object or we can close this as rejected? I'd wait few days before closing.

#11 - 03/03/2016 10:02 AM - Marek Hulán
- Status changed from New to Rejected

Closing, feel free to reopen if you disagree.
